// CFecha.cpp: implementation of the CFecha class.
//
//////////////////////////////////////////////////////////////////////

#include "CFecha.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFecha::CFecha()  //constructor por defecto
{
	t.tm_hour=0;
	t.tm_isdst=-1;
	t.tm_mday=0;
	t.tm_min=0;
	t.tm_mon=0;
	t.tm_sec=1;
	t.tm_wday=0;
	t.tm_yday=0;
	t.tm_year=0;
	
	t=adj(t);

}
CFecha::CFecha(int d, int m, int a)
{					//constructor con dd/mm/aa
	t.tm_hour=0;
	t.tm_isdst=-1;
	t.tm_mday=d;
	t.tm_min=0;
	t.tm_mon=m;
	t.tm_sec=0;
	t.tm_wday=0;
	t.tm_yday=0;
	t.tm_year=a;

	t=adj(t);	//ajusta los valores y calcula el dia de la semana

}
CFecha::~CFecha()  //destructor
{

}

int CFecha::VDia() const	//funciones que muestran el dia, mes y ao
{							// el dia de la semana
	return(t.tm_mday);
}

int CFecha::VDiaS() const
{
	return(t.tm_wday);
}

int CFecha::VMes() const
{
	return(t.tm_mon);
}
int CFecha::VAno() const
{
	return(t.tm_year);
}

int CFecha::MDia(int d)		// funciones que permiten cambiar el dia, mes y ao
{
	t.tm_mday=d;
	t=adj(t);
	return (t.tm_mday);
}

int CFecha::MMes(int m)
{
	t.tm_mon=m;
	t=adj(t);
	return(t.tm_mon);
}

int CFecha::MAno(int a)
{
	t.tm_year=a;
	t=adj(t);
	return(t.tm_year);
}

long CFecha::AHora()		// entrega la fecha actual en forma de un long
{							// que tiene el numero de dias desde el 1/1/70
	time_t tt;
	tt=time(NULL);

	return (tt/86400);
}

tm adj (tm t)				// calcula el dia de la semana
{							// y ajusta los valores del calendario
	time_t tt;
	tt=mktime(&t);
	return(*localtime(&tt));
}

CFecha operator+(CFecha F1, CFecha F2) 
{
	CFecha F;				//define la suma de 2 fechas
	F.MDia(F1.VDia()+F2.VDia()); // pero no realiza ajustes, por problemas de desborde
	F.MMes(F1.VMes()+F2.VMes()); // la idea es hacer los ajustes despus, sabiendo
	F.MAno(F1.VAno()+F2.VAno()); // que la fecha est en un rango valido
	return(F);
}
