// Tiempo.cpp: implementation of the CTiempo class.
//
//////////////////////////////////////////////////////////////////////

#include "CTiempo.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTiempo::CTiempo()		//constructor por defecto
{
	t=juntar(f.t,h.t);
}
CTiempo::CTiempo(int d, int m, int a,int hr, int mi, int s)
{
	f.MAno(a);			//constructor con la defnicion de el tiempo
	f.MMes(m);
	f.MDia(d);
	h.MHora(hr);
	h.MMin(mi);
	h.MSeg(s);
	t=juntar(f.t,h.t);
	t=adj(t);
}

CTiempo::~CTiempo()
{

}
void CTiempo::Cambiar(int d, int m, int a,int hr, int mi, int s)
{
	f.MAno(a);			// cambia el tiempo de un objeto CTiempo
	f.MMes(m);
	f.MDia(d);
	h.MHora(hr);
	h.MMin(mi);
	h.MSeg(s);
	t=juntar(f.t,h.t);
	t=adj(t);
}

int CTiempo::VDia(void) const	//estas funciones muestran cada una de las
{								//variables del tiempo
	return(t.tm_mday);
}
int CTiempo::VDiaS(void) const
{
	return(t.tm_wday);
}

int CTiempo::VMes(void) const
{
	return(t.tm_mon);
}

int CTiempo::VAno(void) const
{
	return(t.tm_year);
}
int CTiempo::VHora(void) const
{
	return(t.tm_hour);
}

int CTiempo::VMin(void) const
{
	return(t.tm_min);
}

int CTiempo::VSeg(void) const
{
	return(t.tm_sec);
}

CTiempo CTiempo::AHora(void)	//devuelve un objeto CTiempo con el tiempo actual
{
	CTiempo c;
	struct tm *ta;
	time_t tt;
	tt=time(NULL);
	ta=localtime(&tt);
	c.t=*ta;
	return(c);
}

tm juntar(tm t1, tm t2)			// junta una variable de tiempo con otra
{								// es similar a una suma, pero no ajusta
	tm t;						// los valores internos
	t.tm_hour=t1.tm_hour+t2.tm_hour;
	t.tm_isdst=-1;
	t.tm_mday=t1.tm_mday+t2.tm_mday;
	t.tm_min=t1.tm_min+t2.tm_min;
	t.tm_mon=t1.tm_mon+t2.tm_mon;
	t.tm_sec=t1.tm_sec+t2.tm_sec;
	t.tm_wday=0;
	t.tm_yday=0;
	t.tm_year=t1.tm_year+t2.tm_year;
	return (t);
}

bool operator>(CTiempo t1, CTiempo t2)	//define el operador >
{
	if (mktime(&t1.t)>mktime(&t2.t)) return (true);
	return (false);
}

CTiempo operator-(CTiempo t1, CTiempo t2)
{
	CTiempo t;					// define la resta de 2 tiempos
	time_t tt;					// hay que usarla con precaucion
	tt=mktime(&t1.t)-mktime(&t2.t);
	t.t=*localtime(&tt);		// ya que no es muy fiable
	t.f.MAno(t.t.tm_year);		//El 0 es el ao 1970
	t.f.MMes(t.t.tm_mon);
	t.f.MDia(t.t.tm_mday); 
	t.h.MMin(t.t.tm_min);
	t.h.MSeg(t.t.tm_sec);
	return (t);
}

CTiempo operator/(CTiempo F1, int i)
{
	CTiempo F;					//define la division por entero
	int j;						// y arrastea los residuos
	F.f.MAno(F1.f.VAno()/i);	// de cada division para mantener
	j=(F1.f.VAno()%i)*365;		// la precision
	F.f.MDia((F1.f.VDia()+j)/i);
	j=((F1.f.VDia()+j)%i)*24;
	F.f.MDia((F1.f.VDia()+j)/i);
	j=((F1.f.VDia()+j)%i)*24;
	F.h.MHora((j+F1.h.VHora())/i);
	j=((F1.h.VHora()+j)%i)*60;
	F.h.MMin((j+F1.h.VMin())/i);
	j=((F1.h.VMin()+j)%i)*60;
	F.h.MSeg((j+F1.h.VSeg())/i);

	F.t=adj(F.t);
	return (F);
}

CTiempo operator+(CTiempo t1, CTiempo t2)
{
	CTiempo t;					// define la suma en base al metodo cambiar
	t.Cambiar(t1.VDia()+t2.VDia(), t1.VMes()+t2.VMes(), t1.VAno()+t2.VAno(), t1.VHora()+t2.VHora(), t1.VMin()+t2.VMin(),t1.VSeg()+t2.VSeg());
	return(t);
}
